lavc/x264: Also clean-up libx264rgb after init errors.
[ffmpeg.git] / LICENSE.md
1 # License
2
3 Most files in FFmpeg are under the GNU Lesser General Public License version 2.1
4 or later (LGPL v2.1+). Read the file `COPYING.LGPLv2.1` for details. Some other
5 files have MIT/X11/BSD-style licenses. In combination the LGPL v2.1+ applies to
6 FFmpeg.
7
8 Some optional parts of FFmpeg are licensed under the GNU General Public License
9 version 2 or later (GPL v2+). See the file `COPYING.GPLv2` for details. None of
10 these parts are used by default, you have to explicitly pass `--enable-gpl` to
11 configure to activate them. In this case, FFmpeg's license changes to GPL v2+.
12
13 Specifically, the GPL parts of FFmpeg are:
14
15 - libpostproc
16 - optional x86 optimization in the files
17     - `libavcodec/x86/flac_dsp_gpl.asm`
18     - `libavcodec/x86/idct_mmx.c`
19     - `libavfilter/x86/vf_removegrain.asm`
20 - the following building and testing tools
21     - `compat/solaris/make_sunver.pl`
22     - `doc/t2h.pm`
23     - `doc/texi2pod.pl`
24     - `libswresample/tests/swresample.c`
25     - `tests/checkasm/*`
26     - `tests/tiny_ssim.c`
27 - the following filters in libavfilter:
28     - `signature_lookup.c`
29     - `vf_blackframe.c`
30     - `vf_boxblur.c`
31     - `vf_colormatrix.c`
32     - `vf_cover_rect.c`
33     - `vf_cropdetect.c`
34     - `vf_delogo.c`
35     - `vf_eq.c`
36     - `vf_find_rect.c`
37     - `vf_fspp.c`
38     - `vf_geq.c`
39     - `vf_histeq.c`
40     - `vf_hqdn3d.c`
41     - `vf_kerndeint.c`
42     - `vf_lensfun.c` (GPL version 3 or later)
43     - `vf_mcdeint.c`
44     - `vf_mpdecimate.c`
45     - `vf_nnedi.c`
46     - `vf_owdenoise.c`
47     - `vf_perspective.c`
48     - `vf_phase.c`
49     - `vf_pp.c`
50     - `vf_pp7.c`
51     - `vf_pullup.c`
52     - `vf_repeatfields.c`
53     - `vf_sab.c`
54     - `vf_signature.c`
55     - `vf_smartblur.c`
56     - `vf_spp.c`
57     - `vf_stereo3d.c`
58     - `vf_super2xsai.c`
59     - `vf_tinterlace.c`
60     - `vf_uspp.c`
61     - `vf_vaguedenoiser.c`
62     - `vsrc_mptestsrc.c`
63
64 Should you, for whatever reason, prefer to use version 3 of the (L)GPL, then
65 the configure parameter `--enable-version3` will activate this licensing option
66 for you. Read the file `COPYING.LGPLv3` or, if you have enabled GPL parts,
67 `COPYING.GPLv3` to learn the exact legal terms that apply in this case.
68
69 There are a handful of files under other licensing terms, namely:
70
71 * The files `libavcodec/jfdctfst.c`, `libavcodec/jfdctint_template.c` and
72   `libavcodec/jrevdct.c` are taken from libjpeg, see the top of the files for
73   licensing details. Specifically note that you must credit the IJG in the
74   documentation accompanying your program if you only distribute executables.
75   You must also indicate any changes including additions and deletions to
76   those three files in the documentation.
77 * `tests/reference.pnm` is under the expat license.
78
79
80 ## External libraries
81
82 FFmpeg can be combined with a number of external libraries, which sometimes
83 affect the licensing of binaries resulting from the combination.
84
85 ### Compatible libraries
86
87 The following libraries are under GPL version 2:
88 - avisynth
89 - frei0r
90 - libcdio
91 - libdavs2
92 - librubberband
93 - libvidstab
94 - libx264
95 - libx265
96 - libxavs
97 - libxavs2
98 - libxvid
99
100 When combining them with FFmpeg, FFmpeg needs to be licensed as GPL as well by
101 passing `--enable-gpl` to configure.
102
103 The following libraries are under LGPL version 3:
104 - gmp
105 - libaribb24
106 - liblensfun
107
108 When combining them with FFmpeg, use the configure option `--enable-version3` to
109 upgrade FFmpeg to the LGPL v3.
110
111 The VMAF, mbedTLS, RK MPI, OpenCORE and VisualOn libraries are under the Apache License
112 2.0. That license is incompatible with the LGPL v2.1 and the GPL v2, but not with
113 version 3 of those licenses. So to combine these libraries with FFmpeg, the
114 license version needs to be upgraded by passing `--enable-version3` to configure.
115
116 The smbclient library is under the GPL v3, to combine it with FFmpeg,
117 the options `--enable-gpl` and `--enable-version3` have to be passed to
118 configure to upgrade FFmpeg to the GPL v3.
119
120 ### Incompatible libraries
121
122 There are certain libraries you can combine with FFmpeg whose licenses are not
123 compatible with the GPL and/or the LGPL. If you wish to enable these
124 libraries, even in circumstances that their license may be incompatible, pass
125 `--enable-nonfree` to configure. This will cause the resulting binary to be
126 unredistributable.
127
128 The Fraunhofer FDK AAC and OpenSSL libraries are under licenses which are
129 incompatible with the GPLv2 and v3. To the best of our knowledge, they are
130 compatible with the LGPL.